package itso.mqe.security;

import  examples.awt.*;
import  com.ibm.mqe.*;
/*------------------------------------------------------------------------------*/
/* Class:                                                                       */
/*                                                                              */
/*      LogonAuthenticator                                                      */
/*                                                                              */
/* Extends:                                                                     */
/*                                                                              */
/*      MQeAuthenticator                                                        */
/*                                                                              */
/* Function:                                                                    */
/*                                                                              */
/*      base logon Authentication support                                       */
/*                                                                              */
/* Contains:                                                                    */
/*                                                                              */
/*      not a lot                                                               */
/*                                                                              */
/* History:                                                                     */
/*                                                                              */
/*      Created         06/Jul/1999                                             */
/*                                                                              */
/*------------------------------------------------------------------------------*/
public class QueueAuthenticator extends MQeAuthenticator 
  {
  public    static short  version[] = {1, 2, 4};

  protected final static String Authentic_ID       = "AID";
  private                String authID             = null;

  private   AuthWindow  authWindow = null;
  
  /*----------------------------------------------------------------------------*/
  /* Constructor                                                                */
  /*----------------------------------------------------------------------------*/
  public QueueAuthenticator( )
    {                                           /*                              */
    }                                           /*                              */
  /*----------------------------------------------------------------------------*/
  /* Activate Master                                                            */
  /*----------------------------------------------------------------------------*/
  public byte[] activateMaster( boolean local ) throws Exception
    {  

	System.out.println("In activateMaster: " + local);

	/* if this method invoked by the queue manager where the queue
	   actually resides, then we just leave, implication being that
	   the queue manager that owns the queue has unlimited access */
	
	if (local) {
		String replyTxt = "No checking required";
 		byte [] replyMsg = replyTxt.getBytes();
 		return replyMsg;
	}

    String password = null;                     
    String userid   = "Not Required";                                        
    String domain = "None";             
 
    /* display a Dialog - prompting for Domain, Userid and password             */
 
    while ( password == null )               /* have the data ?              */
      {                                        
 
      /* Use sample class supplied as part of MQSeries Everyplace
         to display dialog box to ask for a password */

      AwtDialog ntd = new AwtDialog( "Managers Password",
                                     AwtDialog.Show_OK_Cancel,
                                     new String[][][]
       { { { "L", "Domain"   /* Index 0 */ }, { "T",  domain   /* Index 1 */ } },
         { { "L", "Userid"   /* Index 2 */ }, { "T",  userid   /* Index 3 */ } },
         { { "L", "Password" /* Index 4 */ }, { "T*", ""       /* Index 5 */ } } } );

      if ( ntd.getActionIndex( ntd.South ) != ntd.Button_OK  )  /* OK ?         */
        throw new MQeException( Except_Stopped, "Canceled" );   /* ... no       */
             password = ntd.getText( AwtDialog.Center, 5 ) ;    /* reply        */
                System.out.println(domain + userid + password);

      System.out.println(domain + userid + password);
      ntd.dispose();
      }             

    /* Password entered by user is passed back to queue manager, which 
       will send it to the corresponding activateSlave method on the server
       queue manager */
       	
 	System.out.println("pwd: " + password);
 	String replyTxt = "From Master: " + password;
 	byte [] replyMsg = replyTxt.getBytes();
 	return replyMsg;

    }                                           /*                              */
  /*----------------------------------------------------------------------------*/
  /* Activate Slave                                                             */
  /*----------------------------------------------------------------------------*/
  public byte[] activateSlave(  boolean local,
                                byte    data[] ) throws Exception
    {        
	byte [] replyMsg = null;
   	if (local) {
		String replyTxt = "Access allowed for local";
 		replyMsg = replyTxt.getBytes();
 		return replyMsg;
	}
		
	String recvMsg =  new String(data);
	System.out.println("Slave got: " + recvMsg);
	String authID = "Edward";
 		
 	if (recvMsg.indexOf("shazam") > 0){
    try                                       
     {                                       
       setAuthenticatedID( authID );          

       replyMsg = "From Slave: Auth ok: ".getBytes();

       return replyMsg;
 
        }                                       /*                              */
    catch ( Exception e )                       /* error occured                */
      {                                         /*                              */
      authID = null;                            /* make sure authID is null     */
      setAuthenticatedID( null );               /* invalidate                   */
      throw e;                                  /* re-throw the exception       */
      }                                         /*                              */
 		}
 		else {
	 		authID = null;
	 		setAuthenticatedID( null );
	 		throw new Exception() ;
 		}
      }                                           /*                              */
  /*----------------------------------------------------------------------------*/
  /* close the authenticator                                                    */
  /*----------------------------------------------------------------------------*/
  public void close( )
    {                                           /*                              */
    if ( authID != null )                       /* logged on ?                  */
      {                                         /* ... yes                      */
      trace( "_:Logoff " + authID );            /*                              */
      authID = null;
      }                                         /*                              */
    super.close( );                             /* call ancestor                */
    }                                           /*                              */
/**
 * Insert the method's description here.
 * Creation date: (9/25/2001 9:35:59 AM)
 * @return java.lang.String
 * @param data java.lang.String
 */
public String mask(String data) {

    { /*                              */
        byte temp[] = MQe.asciiToByte(data); /* convert to byte array        */
        for (int i = temp.length - 1; i >= 0; i = i - 1) /* for whole password   */
            temp[i] = (byte) (temp[i] ^ (i + 0x00A5)); /* simple mask          */
        return (MQe.byteToAscii(temp)); /* return the masked string     */
    } /*                              */

} /* end class                    */
  /*----------------------------------------------------------------------------*/
  /* Prompt to enter data                                                       */
  /*----------------------------------------------------------------------------*/
  protected void prompt( MQeFields fields ) throws Exception
    {                                           /*                              */
    throw new MQeException( MQe.Except_NotSupported, "Not supported" );
    }                                           /*                              */
  /*----------------------------------------------------------------------------*/
  /* Slave response - set the Authenticated ID                                  */
  /*----------------------------------------------------------------------------*/
  public void slaveResponse(    boolean local,
                                byte    data[] ) throws Exception
    {                                           /*                              */
	    System.out.println("In slaveResponse...");
	    String authID = "Edward";
		setAuthenticatedID(authID);

    }                                           /*                              */
  /*----------------------------------------------------------------------------*/
  /* Validate the data                                                          */
  /*----------------------------------------------------------------------------*/
  protected String validate( MQeFields fields ) throws Exception
    {                                           /*                              */
    throw new MQeException( MQe.Except_Authenticate, "Authenticate failed" );
    }                                           /*                              */
}                                             /* end class                    */
