package itso.mqe.was;

/**
 * Insert the type's description here.
 * Creation date: (9/21/2001 10:43:11 AM)
 * @author: Administrator
 */
 import com.ibm.mqe.*;
 import com.ibm.mqe.registry.*;
 import java.util.*;
 import java.io.*;

import  javax.servlet.*;
import  javax.servlet.http.*;
 
public class ITSOMQeServlet extends javax.servlet.http.HttpServlet {
	    public final static String      Section_ChannelManager = "ChannelManager";
    public final static String      Section_Listener     = "Listener";
        public String defaultStartupInifile     = "./ServerMq.ini";

	protected WasQMgr  myMQe = null;
        
    protected MQe                   mqe             = new MQe();
    protected MQeChannelManager     channelManager  = null; // Channel mgr object
    protected MQeQueueManager       qMgr            = null; // Queue manager object
   // protected MQeChannelTimer       channelTimer    = null; // Channel timeout monitor
    protected Hashtable             loadTable       = null; // Preloaded objects

    public final static String      Section_QueueManager = "QueueManager";
	public final static String      Section_Alias        = "Alias";
	String chatClientViaWas = "ChatClientQViaWas";
	String clientQMgr = "ClientQm";
   //   String iniFile = "C:\\ES02WAS\\WASServerQm.ini";
	String iniFile = null;
   
/**
 * Process incoming HTTP POST requests 
 * 
 * @param request Object that encapsulates the request to the servlet 
 * @param response Object that encapsulates the response from the servlet
 */
public void doPost(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) throws javax.servlet.ServletException, java.io.IOException {

//	performTask(request, response);

	    // any request to process ?
    if (request == null)
        throw new IOException("Invalid request");

    try
    {
        int max_length_of_data = request.getContentLength();    // data length
        byte[] httpInData = new byte[max_length_of_data];       // allocate data area

        ServletOutputStream httpOut = response.getOutputStream();// output stream
        ServletInputStream  httpIn  = request.getInputStream(); // input stream

        // get the request
        read( httpIn, httpInData, max_length_of_data);

        String mqeInput = new String(httpInData);
        //System.out.println("MQeInput: " + "mqeInput");
        
        // process the request
        byte[] httpOutData = channelManager.process(null, httpInData);
        String mqeReply = new String(httpOutData);
        //System.out.println("MQeReply: " + "mqeReply");

        // appears to be an error in that content-length is not being set
        // so we will set it here
        response.setContentLength(httpOutData.length);
        response.setIntHeader("content-length", httpOutData.length);

        // Pass back the response
        httpOut.write(httpOutData);
    }
    catch (Exception e)
    {
        // pass it on ...
        throw new IOException( "Request failed" + e );
    }

}
/**
 * Initializes the servlet.
 */
public void init(ServletConfig sc) throws ServletException{

	super.init(sc);
   
      String mqePropName = "MQe";
      boolean YourCoOn = false;

        try {
 
            PropertyResourceBundle resourceBundle =
                (PropertyResourceBundle) PropertyResourceBundle.getBundle(mqePropName);
            iniFile = resourceBundle.getString("IniFile");
            String YourCoFlag = resourceBundle.getString("YourCo");
            if (YourCoFlag.indexOf("Yes") >= 0) YourCoOn = true;

        } catch (Exception e) {

            System.out.println(
                (new java.util.Date())
                    + " get MQe properties - Unexpected exception " + e);
        }
	
	System.out.println( "..Start a queue manager using ini file: " + iniFile );
    try
    {
      // Access the file
        File diskFile   = new File( iniFile );

        // Create a byte array big enough to hold the file's contents.
        byte data[]     = new byte[(int) diskFile.length()];

        // Read the file into the byte array and close the file.
        FileInputStream inputFile = new FileInputStream( diskFile );
        inputFile.read( data );
        inputFile.close( );

        // Read the data into a buffer where it can be manipulated.
        StringBuffer configDataBuff = new StringBuffer( mqe.byteToAscii( data ) );

        // We want to look for single \n characters which are not adjacent to \r
        // characters. ie; On Unix systems, if someone uses vi or similar editor 
        // to edit the .ini file, then lines will end in \n only.
        // To make MQe more tolerant of this, we convert lone \n characters to \r\n
        // sequences so the .ini files can cope.
        // This has the side-effect of dis-allowing embedded \n characters in an .ini
        // file, but this compromise is seen as being acceptable.

        // Method: Work through all the configuration information. 
        // If we find a single \n character, insert a \r character before it.
        char prevChar = '\0';
        char thisChar = '\0';
        for ( int along = 0 ; 
            along < configDataBuff.length(); 
            along +=1 
            ) {
            prevChar = thisChar ;
            thisChar = configDataBuff.charAt( along );
            if (  (thisChar == '\n') && (prevChar != '\r') ) {
                // The character under strutiny was a '\n' on it's own.
                // Turn it into a '\r\n'
                configDataBuff.insert( along , '\r' );
                // Skip the along counter on one, so we don't look at the same
                // '\n' character again.
                along +=1 ;
            } else {
                // The character under scrutiny was not a '\n' on it's own, 
                //  so just leave it alone. 
            }
        }

        MQeFields iniSections = MQeFields.restoreFromString( "\r\n",       // end of record string
                                                        "[#0]",       // section pattern
                                                        "(#0)#1=#2",  // keyword pattern
                                                        configDataBuff.toString() + "\r\n" );

        qMgr = new MQeQueueManager();
 
        if ( iniSections.contains( Section_Alias ) ) {

            // Get all the fields inside the alias section
            MQeFields section = iniSections.getFields( Section_Alias );
            Enumeration keys  = section.fields( );
            while ( keys.hasMoreElements() ) {

                // For each key, get the value and add the mapping to the MQe
                // internal alias table
                String    key   = (String) keys.nextElement();
                MQe.alias( key, section.getAscii( key ).trim( ) );
            }

        //    sectionProcessed(Section_Alias);
        }

        // If there is a ChannelManager section attempt to
        // create a new channel manager, and set the maximum number
        // of channels to the value specified in the ini file.
      
        if ( iniSections.contains( Section_ChannelManager ) ) {
            MQeFields section = iniSections.getFields( Section_ChannelManager );
            channelManager    = new MQeChannelManager( );
            channelManager.numberOfChannels( section.getInt( "MaxChannels" ) );
          //  sectionProcessed(Section_ChannelManager);
        }

        
        if ( iniSections.contains( Section_QueueManager) ) {
            qMgr = (MQeQueueManager) MQe.loader.loadObject( Section_QueueManager );
            if ( qMgr != null ) {

                // Activate the queue manager.
                qMgr.setGlobalHashTable( channelManager.getGlobalHashtable( ) );
                qMgr.activate( iniSections );

			    myMQe = new WasQMgr(qMgr);

			    if (YourCoOn) 
                	qMgr.addMessageListener (myMQe, "YourCoQuery", null);
                qMgr.addMessageListener (myMQe, chatClientViaWas, null);
                // Processing was successful.
  
            }
        }
        
        String qMgrName = qMgr.getName();

        System.out.println( "..Active Everyplace queue manager: " + qMgrName );

    }
    catch (Exception ex)
    {
        System.out.println( "..Start of queue manager failed: " + ex );
     }
    return ;

}
/**
 * Process incoming requests for information
 * 
 * @param request Object that encapsulates the request to the servlet 
 * @param response Object that encapsulates the response from the servlet
 */
public void performTask(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response) {

	try

	{
		// Insert user code from here.

	}
	catch(Throwable theException)
	{
		// uncomment the following line when unexpected exceptions
		// are occuring to aid in debugging the problem.
		//theException.printStackTrace();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (9/21/2001 11:40:32 AM)
 * @param in java.io.InputStream
 * @param data byte[]
 * @param bytes int
 * @exception java.io.IOException The exception description.
 */
public void read(InputStream in, byte[] data, int bytes) throws java.io.IOException {
	    int i = 0;                                  // Bytes read so far

    // Carry on getting bytes until we have the required number
    while ( i < bytes )
    {
        int numBytes = 0;                       // Bytes read on this read

        numBytes = in.read( data, i, bytes-i ); // read next batch of bytes

        // Check for possible end of file
        if ( numBytes < 0 )
            throw new EOFException( );

        i = i + numBytes;                       // Increment bytes read count
    }
	}
}
