package itso.mqe.was;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

/**
 * This servlet does the minimum amount of work that a servlet could possibly do.
 * Execution of the servlet should show the base-line for servlet response times
 * in the application server.
 */
public class PingServlet extends GenericServlet
{

    //pre-allocate the message so that it is only created once.
    static final String message = "<html>\n" +
                "<head><title>Ping Servlet</title></head>\n" +
                "<body>\n" + 
                "<h1>An ITSO Ping!</h1>\n" + 
                "</body></html>\n";
    static final byte[] bytes = message.getBytes();

    public void destroy()
    {
        log("PingServlet.destroy()");
    }
    public void init()
    {
        log("PingServlet.init()");
    }
    public void service(ServletRequest req, ServletResponse res)
    throws ServletException, IOException
    {
        //use the outputstream to avoid the writer's
        //character-to-byte decoding step.
        res.getOutputStream().write(bytes);
    }
}
